Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml.cs	(revision 5539)
@@ -0,0 +1,139 @@
+﻿using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Runtime.InteropServices.WindowsRuntime;
+using Windows.ApplicationModel;
+using Windows.ApplicationModel.Activation;
+using Windows.Foundation;
+using Windows.Foundation.Collections;
+using Windows.UI.Xaml;
+using Windows.UI.Xaml.Controls;
+using Windows.UI.Xaml.Controls.Primitives;
+using Windows.UI.Xaml.Data;
+using Windows.UI.Xaml.Input;
+using Windows.UI.Xaml.Media;
+using Windows.UI.Xaml.Navigation;
+using VoipTasks.BackgroundOperations;
+using VoipUI.Helpers;
+using System.Diagnostics;
+
+namespace VoipUI
+{
+    /// <summary>
+    /// Provides application-specific behavior to supplement the default Application class.
+    /// </summary>
+    sealed partial class App : Application
+    {
+        /// <summary>
+        /// Initializes the singleton application object.  This is the first line of authored code
+        /// executed, and as such is the logical equivalent of main() or WinMain().
+        /// </summary>
+        public App()
+        {
+            Microsoft.ApplicationInsights.WindowsAppInitializer.InitializeAsync(
+                Microsoft.ApplicationInsights.WindowsCollectors.Metadata |
+                Microsoft.ApplicationInsights.WindowsCollectors.Session);
+            this.InitializeComponent();
+            this.Suspending += OnSuspending;
+        }
+
+        /// <summary>
+        /// Invoked when the application is launched normally by the end user.  Other entry points
+        /// will be used such as when the application is launched to open a specific file.
+        /// </summary>
+        /// <param name="e">Details about the launch request and process.</param>
+        protected override void OnLaunched(LaunchActivatedEventArgs e)
+        {
+
+#if DEBUG
+            if (System.Diagnostics.Debugger.IsAttached)
+            {
+                this.DebugSettings.EnableFrameRateCounter = true;
+            }
+#endif
+
+            Frame rootFrame = Window.Current.Content as Frame;
+
+            // Do not repeat app initialization when the Window already has content,
+            // just ensure that the window is active
+            if (rootFrame == null)
+            {
+                // Create a Frame to act as the navigation context and navigate to the first page
+                rootFrame = new Frame();
+
+                rootFrame.NavigationFailed += OnNavigationFailed;
+
+                if (e.PreviousExecutionState == ApplicationExecutionState.Terminated)
+                {
+                    //TODO: Load state from previously suspended application
+                }
+
+                // Place the frame in the current Window
+                Window.Current.Content = rootFrame;
+            }
+
+            if (rootFrame.Content == null)
+            {
+                // When the navigation stack isn't restored navigate to the first page,
+                // configuring the new page by passing required information as a navigation
+                // parameter
+                rootFrame.Navigate(typeof(MainPage), e.Arguments);
+            }
+
+            /* Start service. */
+            StartServiceAsync();
+
+            // Ensure the current window is active
+            Window.Current.Activate();
+        }
+
+        private async void GetAccountInfoAsync()
+        {
+            try
+            {
+                OperationResult result = await EndpointHelper.GetAccountInfo();
+            }
+            catch (Exception ex)
+            {
+                Debug.WriteLine(ex.Message);
+            }
+        }
+
+        private async void StartServiceAsync()
+        {
+            try
+            {
+                OperationResult result = await EndpointHelper.StartServiceAsync();                                    
+            }
+            catch (Exception ex)
+            {
+                Debug.WriteLine(ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// Invoked when Navigation to a certain page fails
+        /// </summary>
+        /// <param name="sender">The Frame which failed navigation</param>
+        /// <param name="e">Details about the navigation failure</param>
+        void OnNavigationFailed(object sender, NavigationFailedEventArgs e)
+        {
+            throw new Exception("Failed to load Page " + e.SourcePageType.FullName);
+        }
+
+        /// <summary>
+        /// Invoked when application execution is being suspended.  Application state is saved
+        /// without knowing whether the application will be terminated or resumed with the contents
+        /// of memory still intact.
+        /// </summary>
+        /// <param name="sender">The source of the suspend request.</param>
+        /// <param name="e">Details about the suspend request.</param>
+        private void OnSuspending(object sender, SuspendingEventArgs e)
+        {
+            var deferral = e.SuspendingOperation.GetDeferral();
+            //TODO: Save application state and stop any background activity
+            deferral.Complete();
+        }
+    }
+}
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/AppServiceHelper.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/AppServiceHelper.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/AppServiceHelper.cs	(revision 5539)
@@ -0,0 +1,218 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+using System;
+using System.Threading.Tasks;
+using VoipTasks.BackgroundOperations;
+using Windows.ApplicationModel.AppService;
+using Windows.Foundation.Collections;
+using Windows.ApplicationModel.Core;
+using Windows.UI.Core;
+
+namespace VoipUI.Helpers
+{
+    class AppServiceHelper
+    {
+        ~AppServiceHelper()
+        {
+            if (_appConnection != null)
+            {
+                _appConnection.Dispose();
+                _appConnection = null;
+            }
+        }
+
+        public async Task<ValueSet> SendMessageAsync(ValueSet message)
+        {
+            ValueSet returnValue = null;
+            AppServiceConnection appConnection = await GetAppConnectionAsync();
+
+            if (appConnection != null)
+            {
+                AppServiceResponse response = await appConnection.SendMessageAsync(message);
+
+                if (response.Status == AppServiceResponseStatus.Success)
+                {
+                    if (response.Message.Keys.Contains(BackgroundOperation.Result))
+                    {
+                        returnValue = response.Message;
+                    }
+                }
+            }
+
+            return returnValue;
+        }
+
+        public async void SendMessage(ValueSet message)
+        {
+            AppServiceConnection appConnection = await GetAppConnectionAsync();
+
+            if (appConnection != null)
+            {
+                await appConnection.SendMessageAsync(message);
+            }
+        }
+
+        private async Task<AppServiceConnection> GetAppConnectionAsync()
+        {
+            AppServiceConnection appConnection = _appConnection;
+
+            if (appConnection == null)
+            {
+                appConnection = new AppServiceConnection();
+
+                appConnection.ServiceClosed += AppConnection_ServiceClosed;
+
+                appConnection.AppServiceName = BackgroundOperation.AppServiceName;
+
+                appConnection.PackageFamilyName = Windows.ApplicationModel.Package.Current.Id.FamilyName;
+
+                AppServiceConnectionStatus status = await appConnection.OpenAsync();
+
+                if (status == AppServiceConnectionStatus.Success)
+                {
+                    _appConnection = appConnection;
+                    _appConnection.RequestReceived += Connection_RequestReceived;
+                }
+            }
+
+            return appConnection;
+        }
+
+        private void AppConnection_ServiceClosed(AppServiceConnection sender, AppServiceClosedEventArgs args)
+        {
+            _appConnection = null;
+        }
+
+        private async void Connection_RequestReceived(AppServiceConnection sender, AppServiceRequestReceivedEventArgs args)
+        {
+            var deferral = args.GetDeferral();
+            var response = new ValueSet();
+            //bool stop = false;
+            try
+            {
+                var request = args.Request;
+                var message = request.Message;
+                if (message.ContainsKey(ForegroundOperation.NewForegroundRequest))
+                {
+                    switch ((ForegroundReguest)message[ForegroundOperation.NewForegroundRequest])
+                    {
+                        case ForegroundReguest.UpdateCallState:
+                            AppRequest = args.Request;
+                            Request = ForegroundReguest.UpdateCallState;
+                            AppRequestDeferal = deferral;
+
+                            await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () => {
+
+                                MainPage.Current.UpdateCallState(message[UpdateCallStateArguments.CallState.ToString()] as String);
+                            });
+                            
+                            break;
+
+                        case ForegroundReguest.UpdateRegState:
+                            AppRequest = args.Request;
+                            Request = ForegroundReguest.UpdateRegState;
+                            AppRequestDeferal = deferral;
+
+                            await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () => {
+
+                                MainPage.Current.UpdateRegState(message[UpdateRegStateArguments.RegState.ToString()] as String);
+                            });
+
+                            break;
+
+                        case ForegroundReguest.UpdateAcccountInfo:
+                            AppRequest = args.Request;
+                            Request = ForegroundReguest.UpdateAcccountInfo;
+                            AppRequestDeferal = deferral;
+
+                            await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () => {
+
+                                MainPage.Current.UpdateAccountInfo(message[UpdateAccountInfoArguments.id.ToString()] as String,
+                                                                   message[UpdateAccountInfoArguments.registrar.ToString()] as String,
+                                                                   message[UpdateAccountInfoArguments.proxy.ToString()] as String,
+                                                                   message[UpdateAccountInfoArguments.username.ToString()] as String,
+                                                                   message[UpdateAccountInfoArguments.password.ToString()] as String);
+                            });
+
+                            break;
+
+                        default:
+                            break;
+                    }
+                }
+            }
+            finally
+            {
+            }
+        }
+
+        public static AppServiceRequest AppRequest
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _appRequest = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _appRequest;
+                }
+            }
+        }
+
+        public static AppServiceDeferral AppRequestDeferal
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _appDeferral = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _appDeferral;
+                }
+            }
+        }
+
+        public static ForegroundReguest Request
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _request = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _request;
+                }
+            }
+        }
+
+        private AppServiceConnection _appConnection = null;
+
+        private static AppServiceRequest _appRequest = null;
+        private static AppServiceDeferral _appDeferral = null;
+        private static ForegroundReguest _request = ForegroundReguest.InValid;
+        private static Object _lock = new Object();
+    }
+}
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/EndpointHelper.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/EndpointHelper.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/EndpointHelper.cs	(revision 5539)
@@ -0,0 +1,99 @@
+﻿/* $Id*/
+/*
+* Copyright (C) 2016 Teluu Inc. (http://www.teluu.com)
+*
+* This program is free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+*
+* You should have received a copy of the GNU General Public License
+* along with this program; if not, write to the Free Software
+* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+*/
+
+using System;
+using System.Threading.Tasks;
+using VoipTasks.BackgroundOperations;
+using Windows.Foundation.Collections;
+using Windows.Foundation.Metadata;
+using VoipBackEnd;
+
+namespace VoipUI.Helpers
+{
+    static class EndpointHelper
+    {
+        public static async Task<OperationResult> StartServiceAsync()
+        {
+            if (!ApiInformation.IsApiContractPresent("Windows.ApplicationModel.Calls.CallsVoipContract", 1))
+            {                
+                return OperationResult.Failed;
+            }
+
+            AppServiceHelper appServiceHelper = new AppServiceHelper();
+
+            ValueSet message = new ValueSet();
+            message[BackgroundOperation.NewBackgroundRequest] = (int)BackgroundRequest.StartService;
+
+            ValueSet response = await appServiceHelper.SendMessageAsync(message);
+
+            if (response != null)
+            {
+                return ((OperationResult)(response[BackgroundOperation.Result]));
+            }
+            return OperationResult.Failed;
+        }
+
+        public static async Task<OperationResult> GetAccountInfo()
+        {
+            if (!ApiInformation.IsApiContractPresent("Windows.ApplicationModel.Calls.CallsVoipContract", 1))
+            {
+                return OperationResult.Failed;
+            }
+
+            AppServiceHelper appServiceHelper = new AppServiceHelper();
+
+            ValueSet message = new ValueSet();
+            message[BackgroundOperation.NewBackgroundRequest] = (int)BackgroundRequest.GetAccountInfo;
+
+            ValueSet response = await appServiceHelper.SendMessageAsync(message);
+
+            if (response != null)
+            {
+                return ((OperationResult)(response[BackgroundOperation.Result]));
+            }
+            return OperationResult.Failed;
+        }
+
+        public static async Task<OperationResult> ModifyAccount(String id, String registrar, String proxy, String username, String password)
+        {
+            if (!ApiInformation.IsApiContractPresent("Windows.ApplicationModel.Calls.CallsVoipContract", 1))
+            {
+                return OperationResult.Failed;
+            }
+
+            AppServiceHelper appServiceHelper = new AppServiceHelper();
+
+            ValueSet message = new ValueSet();
+            message[ModifyAccountArguments.id.ToString()] = id;
+            message[ModifyAccountArguments.registrar.ToString()] = registrar;
+            message[ModifyAccountArguments.proxy.ToString()] = proxy;
+            message[ModifyAccountArguments.username.ToString()] = username;
+            message[ModifyAccountArguments.password.ToString()] = password;
+            message[BackgroundOperation.NewBackgroundRequest] = (int)BackgroundRequest.ModifyAccount;
+
+            ValueSet response = await appServiceHelper.SendMessageAsync(message);
+
+            if (response != null)
+            {
+                return ((OperationResult)(response[BackgroundOperation.Result]));
+            }
+            return OperationResult.Failed;
+        }
+    }
+}
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/VoipCallHelper.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/VoipCallHelper.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/VoipCallHelper.cs	(revision 5539)
@@ -0,0 +1,56 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+using System;
+using System.Threading.Tasks;
+using VoipTasks.BackgroundOperations;
+using Windows.Foundation.Collections;
+using Windows.Foundation.Metadata;
+
+namespace VoipUI.Helpers
+{
+    static class VoipCallHelper
+    {
+        public static async Task<OperationResult> NewOutgoingCallAsync(String dstURI)
+        {
+            if (!ApiInformation.IsApiContractPresent("Windows.ApplicationModel.Calls.CallsVoipContract", 1))
+            {
+                return OperationResult.Failed;
+            }
+
+            AppServiceHelper appServiceHelper = new AppServiceHelper();
+
+            ValueSet message = new ValueSet();
+            message[NewCallArguments.DstURI.ToString()] = dstURI;
+            message[BackgroundOperation.NewBackgroundRequest] = (int)BackgroundRequest.NewOutgoingCall;            
+
+            ValueSet response = await appServiceHelper.SendMessageAsync(message);
+
+            if (response != null)
+            {
+                return ((OperationResult)(response[BackgroundOperation.Result]));
+            }
+
+            return OperationResult.Failed;
+        }
+
+        public static OperationResult EndCallAsync()
+        {
+            AppServiceHelper appServiceHelper = new AppServiceHelper();
+
+            ValueSet message = new ValueSet();
+            message[BackgroundOperation.NewBackgroundRequest] = (int)BackgroundRequest.EndCall;
+
+            appServiceHelper.SendMessage(message);
+            
+            return OperationResult.Succeeded;
+        }
+    }
+}
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/MainPage.xaml
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/MainPage.xaml	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/MainPage.xaml	(revision 5539)
@@ -0,0 +1,136 @@
+﻿<Page
+    x:Class="VoipUI.MainPage"
+    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
+    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
+    xmlns:local="using:VoipUI"
+    xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
+    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
+    mc:Ignorable="d">
+
+    <Grid Background="{ThemeResource ApplicationPageBackgroundThemeBrush}"
+          Margin="5">
+        <Grid.RowDefinitions>
+            <RowDefinition Height="Auto"/>
+            <RowDefinition Height="Auto"/>
+            <RowDefinition Height="*"/>
+        </Grid.RowDefinitions>
+
+        <StackPanel Grid.Row="0">
+            <TextBlock FontSize="12" Text="Pjsua Sample App" Margin="5"/>
+            <TextBox x:Name="txt_CallerName"  Text="Test Account" Margin="5"/>
+            <TextBox x:Name="txt_CallerNumber" Text="sip:192.168.0.103:6000" Margin="5"/>
+        </StackPanel>
+
+        <StackPanel Grid.Row="1">
+            <Grid HorizontalAlignment="Center">
+                <Grid.ColumnDefinitions>
+                    <ColumnDefinition Width="165"/>
+                    <ColumnDefinition Width="165"/>
+                </Grid.ColumnDefinitions>
+                <Grid.RowDefinitions>
+                    <RowDefinition Height="Auto"/>
+                    <RowDefinition Height="Auto"/>
+                    <RowDefinition Height="Auto"/>
+                    <RowDefinition Height="Auto"/>
+                    <RowDefinition Height="Auto"/>
+                    <RowDefinition Height="Auto"/>
+                    <RowDefinition Height="Auto"/>
+                    <RowDefinition Height="Auto"/>
+                    <RowDefinition Height="Auto"/>
+                </Grid.RowDefinitions>
+
+                <Button x:Name="btn_NewOutgoingCall" 
+                        Grid.Column="0" Grid.Row="0" 
+                        Content="Make Call" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Top" 
+                        Width="150" Height="40" 
+                        Margin="5"
+                        Click="btn_NewOutgoingCall_Click"/>
+                <Button x:Name="btn_EndCall" Grid.Column="1"  Grid.Row="0" Content="End Call" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Top" 
+                        Width="150" Height="40" 
+                        Margin="5" Click="btn_EndCall_Click"/>
+
+                <TextBlock x:Name="label1" Grid.Column="0"  Grid.Row="1" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Text="User Id"
+                        Margin="10,5,5,5"/>
+
+                <TextBox x:Name="txt_UserId" Grid.Column="1"  Grid.Row="1"
+                        HorizontalAlignment="Right"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Margin="5" IsEnabled="True"/>
+
+                <TextBlock x:Name="label2" Grid.Column="0"  Grid.Row="2" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Text="Registrar"
+                        Margin="10,5,5,5"/>
+
+                <TextBox x:Name="txt_Registrar" Grid.Column="1"  Grid.Row="2"
+                        HorizontalAlignment="Right"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Margin="5" IsEnabled="True"/>
+
+                <TextBlock x:Name="label3" Grid.Column="0"  Grid.Row="3" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Text="Proxy"
+                        Margin="10,5,5,5"/>
+
+                <TextBox x:Name="txt_Proxy" Grid.Column="1"  Grid.Row="3"
+                        HorizontalAlignment="Right"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Margin="5" IsEnabled="True"/>
+
+                <TextBlock x:Name="label4" Grid.Column="0"  Grid.Row="4" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Text="User Name"
+                        Margin="10,5,5,5"/>
+
+                <TextBox x:Name="txt_RegUserName" Grid.Column="1"  Grid.Row="4"
+                        HorizontalAlignment="Right"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Margin="5" IsEnabled="True"/>
+
+                <TextBlock x:Name="label5" Grid.Column="0"  Grid.Row="5" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Text="Password"
+                        Margin="10,5,5,5"/>
+
+                <TextBox x:Name="txt_Password" Grid.Column="1"  Grid.Row="5"
+                        HorizontalAlignment="Right"  VerticalAlignment="Center" 
+                        Width="150" Height="40" 
+                        Margin="5" IsEnabled="True"/>
+                <Button x:Name="btn_GetAccountInfo" Grid.Column="0"  Grid.Row="6" Content="Get Account Info" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Top" 
+                        Width="150" Height="40" 
+                        Margin="5" Click="btn_GetAccountInfo_Click"/>
+
+                <Button x:Name="btn_ModifyAccount" Grid.Column="1"  Grid.Row="6" Content="Modify Account" 
+                        HorizontalAlignment="Left"  VerticalAlignment="Top" 
+                        Width="150" Height="40" 
+                        Margin="5" Click="btn_ModifyAccount_Click"/>
+
+                <TextBlock x:Name="txt_RegState" Grid.Column="0" Grid.Row="7"
+                    Text="Reg: Not Registered" 
+                    Margin="15,20,5,15" 
+                    VerticalAlignment="Bottom" 
+                    HorizontalAlignment="Center" 
+                    TextWrapping="WrapWholeWords"/>
+
+                <TextBlock x:Name="txt_CallStatus" Grid.Column="1" Grid.Row="7"
+                    Text="Disconnected" 
+                    Margin="15,20,5,15" 
+                    VerticalAlignment="Bottom" 
+                    HorizontalAlignment="Center" 
+                    TextWrapping="WrapWholeWords"/>
+
+            </Grid>
+        </StackPanel>
+
+    </Grid>
+</Page>
Index: /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/MainPage.xaml.cs
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/MainPage.xaml.cs	(revision 5539)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/MainPage.xaml.cs	(revision 5539)
@@ -0,0 +1,136 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+
+using System;
+using VoipUI.Helpers;
+using VoipTasks.BackgroundOperations;
+using Windows.UI.Xaml;
+using Windows.UI.Xaml.Controls;
+using System.Diagnostics;
+using VoipBackEnd;
+using System.Threading;
+using Windows.ApplicationModel.AppService;
+using Windows.UI.Xaml.Navigation;
+
+namespace VoipUI
+{
+    public sealed partial class MainPage : Page
+    {
+        //App developer should include the logic to prevent the user from being
+        //able to call the Start Call async method multiple times. This is out
+        //of the scope of this sample.
+        private int MethodCallUnexpectedTime = -2147483634;
+
+        public static string callerName, callerNumber;
+        public static MainPage Current;        
+
+        public MainPage()
+        {
+            this.InitializeComponent();
+            Current = this;
+        }
+
+        private async void GetAccountInfoAsync()
+        {
+            try
+            {
+                OperationResult result = await EndpointHelper.GetAccountInfo();
+            }
+            catch (Exception ex)
+            {
+                Debug.WriteLine(ex.Message);
+            }
+        }
+
+        private async void ModifyAccountAsync()
+        {
+            try
+            {
+                OperationResult result = await EndpointHelper.ModifyAccount(
+                                           txt_UserId.Text, 
+                                           txt_Registrar.Text, 
+                                           txt_Proxy.Text, 
+                                           txt_RegUserName.Text, 
+                                           txt_Password.Text);
+            }
+            catch (Exception ex)
+            {
+                Debug.WriteLine(ex.Message);
+            }
+        }
+
+        private async void NewOutgoingCallAsync()
+        {
+            try
+            {
+                OperationResult result = await VoipCallHelper.NewOutgoingCallAsync(txt_CallerNumber.Text);
+            }
+            catch (Exception ex)
+            {
+                Debug.WriteLine(ex.Message);
+            }
+        }
+
+        private void EndCall()
+        {
+            try
+            {
+                OperationResult result = VoipCallHelper.EndCallAsync();
+            }
+            catch (Exception ex)
+            {
+                Debug.WriteLine(ex.Message);
+            }
+            txt_CallStatus.Text = "Disconnected";
+        }
+
+        public void UpdateAccountInfo(String id, String registrar, String proxy,
+                                      String username, String password)
+        {
+            txt_UserId.Text = id;
+            txt_Registrar.Text = registrar;
+            txt_Proxy.Text = proxy;
+            txt_RegUserName.Text = username;
+            txt_Password.Text = password;
+        }
+
+        private void btn_NewOutgoingCall_Click(object sender, RoutedEventArgs e)
+        {
+            NewOutgoingCallAsync();
+        }
+
+
+        private void btn_EndCall_Click(object sender, RoutedEventArgs e)
+        {
+            EndCall();
+        }
+
+        public void UpdateCallState(String state)
+        {
+            txt_CallStatus.Text = state;            
+        }
+
+        public void UpdateRegState(String state)
+        {
+            txt_RegState.Text = "Reg:" + state;
+        }
+
+        private void btn_GetAccountInfo_Click(object sender, RoutedEventArgs e)
+        {
+            GetAccountInfoAsync();
+        }
+
+        private void btn_ModifyAccount_Click(object sender, RoutedEventArgs e)
+        {
+            ModifyAccountAsync();
+        }
+    }
+}
